var Game = function(args) {
    Game.prototype.constructor.call(this,args||{});
    this.screens = {
        'Street' : new Game.Street({grid:this})
    };
    this.screen = this.screens['Street'];
}; Game.prototype = new Punx.Grid();
Game.Goon = function(args) {
    Game.Goon.prototype.constructor.call(this,args||{});

    this.sheet = new Image('img/Goon.png');

    this.frames = {
        'left' : [
            [480,8,16,16],
            [504,8,16,16]
        ],
        'up' : [
            [624,8,16,16],
            [648,8,16,16]
        ],
        'right' : [
            [576,8,16,16],
            [600,8,16,16]
        ],
        'down' : [
            [528,8,16,16],
            [552,8,16,16]
        ]
    };

    this.group = 'down';

    this.waiting = false;

    this.move = function(direction,amount) {
        this.group = direction;
        switch (direction) {
            case 'left' : this.x -= amount; break;
            case 'right' : this.x += amount; break;
            case 'up' : this.y -= amount; break;
            case 'down' : this.y += amount; break;
        }
    };

    this.moveToPlayer = function() {
        if (this.stage.player.x < this.x) this.move('left',1);
        else if (stage.player.x > this.x) this.move('right',1);
        if (stage.player.y < this.y) this.move('up',1);
        else if (stage.player.y > this.y) this.move('down',1);
    };

    this.tick = function() {
        if (this.waiting) return;
        else if (!this.busy) {
            this.busy = true;
            window.setTimeout(function(){ // go back to waiting after a random amount of time
                this.waiting = true;
                window.setTimeout(function(){ // start moving again after a second
                    this.waiting = false;
                    this.busy = false;
                }.bind(this),1000);
            }.bind(this),(Math.random()+0.1)*5000);
        }
        this.moveToPlayer();
    };

}; Game.Goon.prototype = new Punx.Sprite.Actor();
Game.Player = function(args) {
    Game.Player.prototype.constructor.call(this,args=args||{});
    this.sheet = new Image('img/Player.png');
    this.frames = {
        'left' : [
            [30,0,15,16],
            [30,29,15,16]
        ],
        'leftAttack' : [
            [24,90,27,15]
        ],
        'up' : [
            [60,0,15,16],
            [60,30,15,16]
        ],
        'upAttack' : [
            [24,90,27,15]
        ],
        'right' : [
            [90,30,15,16],
            [90,0,15,16]
        ],
        'rightAttack' : [
            [24,90,27,15]
        ],
        'down' : [
            [0,0,15,16],
            [0,30,15,16]
        ],
        'downAttack' : [
            [24,90,27,15]
        ],
    };

    this.group = 'right';

    this.update = function() {
        var updated = false;
        with (Punx.Key) {        
            if (key['space']) {
                updated = true;
                this.attack();
            }
        }
        updated |= Game.Player.prototype.update.call(this);
        return updated;
    };

    this.attack = function(stage) {
        if (this.busy) return;
        this.busy = true;
        var group = this.group;
        this.group = group+'Attack';
        setTimeout(function(){
            this.group = group;
            this.busy = false;
        }.bind(this),500);
    };

}; Game.Player.prototype = new Punx.Sprite.Actor.Player();
Game.Street = function(args) {
    args = args || {};
    args.player = new Game.Player({
        x : 300,
        y : 300
    });
    args.w = 2000;
    args.sprites = [
        args.player,
        new Game.Goon({y:320})
    ];
    Game.Street.prototype.constructor.call(this,args);
}; Game.Street.prototype = new Grid.Screen.Stage();

